# Отчет по лабораторной работе № 2 «Система контроля версий Git»

Выполнил: Яшечкин Г. А \
Группа:   А-01-24 \
Проверил: Козлюк Д. А.

Примечание: работа выполнялась на Windows.

1. Создал на рабочем столе каталог lab02 и запустил в нем Git Bash, приглашение:

```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02

```

2. Просмотрел файлы в рабочем каталоге можно командой `ls` — пусто:

```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ ls

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ 
```

3. Создал каталоги Алисы и Боба, создал каталог `project`,
изучил команду `cd` в процессе:

```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ mkdir alice

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ mkdir bob
ivan@HOME-PC MINGW32 /c/Users/ivan/Desktop/lab02
$ cd bob

KУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ cd ..

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ cd alice

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice
$ mkdir project


ivan@HOME-PC MINGW32 /c/Users/ivan/Desktop/lab02/alice
$ ls
project

ivan@HOME-PC MINGW32 /c/Users/ivan/Desktop/lab02/alice
$ cd project
```

4. Инициализировал репозитарий:

```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project
$ git init
Initialized empty Git repository in C:/Users/КУКОЛДИНЬО/Desktop/lab02/alice/proj
ect/.git/

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (master)
$ git branch -m main

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git config user.name 'Alice (YashechkinGA)'
git config user.email 'YashechkinGA@mpei.ru'
```

У меня имя ветки по умолчанию не настроено.
Git создал ветку под названием `master`, что видно в приглашении терминала.
Подсказка говорит о том, как поменять имя ветки.
Я принял решение не менять имя ветки.
5. Изменим имя ветки master, на main для удобства. Применим команду git branch -m main, а затем проверим, создался ли репозиторий, c помощью команды ls -A: 
```
KУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/OneDrive/Рабочий стол/lab02/alice/project (master)
$ git branch -m main

KУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/OneDrive/Рабочий стол/lab02/alice/project (main)
$ ls -A
.git/
```

6. Настроим репозитарий Алисы, чтобы коммиты были от ее имени:
```
KУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW644 ~/OneDrive/Рабочий стол/lab02/alice/project (main)
$ git config user.name 'Alice (YasheckinGA)'
KУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/OneDrive/Рабочий стол/lab02/alice/project (main)
$ git config user.email 'YasheckinGA@mpei.ru'
```
7. Запустил CodeBlocks и создал проект в репозитарии Алисы:
```
##### Параметры были выбраны такие:

Project title: project
Folder to create project in: C:\Users\KУКОЛДИНЬО\OneDrive\Рабочий стол\lab02\alice
Project filename: project.cbp
Resulting filename: C:\Users\KУКОЛДИНЬО\OneDrive\Рабочий стол\lab02\alice\project\project.cbp

##### Структура файлов выглядит таким образом:

lab02
├── alice
│  └── project  <--------- текущий рабочий каталог
│       ├── .git <--------- создан командой "git init"
│       ├── bin  <--------- создан CodeBlocks при сборке
│       ├── obj  <--------- (то же самое)
│       ├── main.cpp    <-- код программы
│       └── project.cbp <-- файл проекта
└── bob
```
8. Вернувшись в Git Bash, просмотрим состояние рабочей копии: 
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git status
On branch main ~выведена информация о текущей ветке main

No commits yet~ в базу данных не помещен ни один коммит

Untracked files:~Чтобы включить неотслеживаемый файл в коммит, нужно использовать команду git add
  (use "git add <file>..." to include in what will be committed)
        bin/
        main.cpp
        obj/
        project.cbp

nothing added to commit but untracked files present (use "git add" to track)
```
9. Добавим файл main.cpp в индекс и сделали с ним коммит 
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git status
On branch main

No commits yet

Changes to be committed:
  (use "git rm --cached <file>..." to unstage)
        new file:   main.cpp

Untracked files:
  (use "git add <file>..." to include in what will be committed)
        bin/
        obj/
        project.cbp
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m 'code: заготовка программы'
[main (root-commit) 98b3f1e] code: заготовка программы
 1 file changed, 9 insertions(+)
 create mode 100644 main.cpp
```
проверили внесение файла
10. аналогично с project.cbp
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add project.cbp
warning: in the working copy of 'project.cbp', LF will be replaced by CRLF the n
ext time Git touches it

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m 'build: add project file'
[main 026a0ad] build: add project file
 1 file changed, 38 insertions(+)
 create mode 100644 project.cbp
```
11. различия между случаем, когда добавлялся новый файл, и когда изменился существующий
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git status
On branch main
Changes not staged for commit:
  (use "git add <file>..." to update what will be committed)
  (use "git restore <file>..." to discard changes in working directory)
        modified:   main.cpp

Untracked files:
  (use "git add <file>..." to include in what will be committed)
        bin/
        obj/

no changes added to commit (use "git add" and/or "git commit -a")
```

12. коммим разность и сумму a b
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m '...'
[main 8700c05] ...
 1 file changed, 4 insertions(+), 1 deletion(-)
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add -u
git commit -m "..."
[main 7076111] ...
 1 file changed, 1 insertion(+)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -a -m "..."
[main cbc3b42] ...
 1 file changed, 1 insertion(+
 ```
 13. заносим в индекс гитигнор
 ```
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add .gitignore
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m 'git'
[main e9f694b] git
 1 file changed, 4 insertions(+)
 create mode 100644 .gitignore
 ```
 14. Просмотрели журнал коммитов (3 способа)
 ```
 commit e9f694bf050b729345b118e1f7174a95d0c8c0fd (HEAD -> main)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:26:22 2025 +0300

    git

 .gitignore | 4 ++++ файл изменен добавилось 4 строки
 1 file changed, 4 insertions(+)

commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

 main.cpp | 1 + добавилась одна строка
 1 file changed, 1 insertion(+)

commit 70761119e12a9928971eadd1c5d8c252254944e9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:01:08 2025 +0300

    ...

 main.cpp | 1 + обавилась одна строка
 1 file changed, 1 insertion(+)

commit 8700c051aabb0fef1c38ddfd2ffa37f8c8e19ec0
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:55:35 2025 +0300

    ...

 main.cpp | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 026a0adb7b4a9be74c8d14efa82762676dd27602
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:42:07 2025 +0300

    build: add project file

 project.cbp | 38 ++++++++++++++++++++++++++++++++++++++
 1 file changed, 38 insertions(+)

commit 98b3f1e8bd7eeb38263439ec1e2b707c5433cff9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:32:19 2025 +0300
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log --oneline --decorate
e9f694b (HEAD -> main) git
cbc3b42 ...
7076111 ...
8700c05 ...
026a0ad build: add project file
98b3f1e code: заготовка программы

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log --oneline --decorate --all --graph
* e9f694b (HEAD -> main) git
* cbc3b42 ...
* 7076111 ...
* 8700c05 ...
* 026a0ad build: add project file
* 98b3f1e code: заготовка программы
последний коммит отображает хэш номер
 ```
 15. показывает затрагивающие main.cpp;  показывает коммиты с code: в сообщении.
```
 
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log -- main.cpp
commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

commit 70761119e12a9928971eadd1c5d8c252254944e9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:01:08 2025 +0300

    ...

commit 8700c051aabb0fef1c38ddfd2ffa37f8c8e19ec0
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:55:35 2025 +0300

    ...

commit 98b3f1e8bd7eeb38263439ec1e2b707c5433cff9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:32:19 2025 +0300

    code: заготовка программы

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log --grep "code:"
commit 98b3f1e8bd7eeb38263439ec1e2b707c5433cff9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:32:19 2025 +0300

    code: заготовка программы
 ```
16. Нашли сначала коммиты по теме build, затем коммиты, затрагивающие project.cbp
```
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log --grep "build"
commit 026a0adb7b4a9be74c8d14efa82762676dd27602
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:42:07 2025 +0300

    build: add project file

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log -- project.cbp
commit 026a0adb7b4a9be74c8d14efa82762676dd27602
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:42:07 2025 +0300

    build: add project file
```
 17. Просмотрели коммит тремя способами
 ```
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show HEAD
commit e9f694bf050b729345b118e1f7174a95d0c8c0fd (HEAD -> main)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:26:22 2025 +0300

    git

diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..c20f4c9
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,4 @@
+/bin
+/obj
+/project.layout
+/project.layout

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show main
commit e9f694bf050b729345b118e1f7174a95d0c8c0fd (HEAD -> main)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:26:22 2025 +0300

    git

diff --git a/.gitignore b/.gitignore
new file mode 100644
index 0000000..c20f4c9
--- /dev/null
+++ b/.gitignore
@@ -0,0 +1,4 @@
+/bin
+/obj
+/project.layout
+/project.layout

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show d2e8af
fatal: ambiguous argument 'd2e8af': unknown revision or path not in the working tree.
Use '--' to separate paths from revisions, like this:
'git <command> [<revision>...] -- [<file>...]'

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show HEAD~1
commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

diff --git a/main.cpp b/main.cpp
index 443df7f..f0a0233 100644
--- a/main.cpp
+++ b/main.cpp
@@ -8,6 +8,7 @@ int main()
 int a, b;
 cin >> a >> b;
 cout << "A + B = " << a + b << '\n';
+cout << "A - B = " << a - b << '\n';

     return 0;
 }

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show cbc3b42
commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

diff --git a/main.cpp b/main.cpp
index 443df7f..f0a0233 100644
--- a/main.cpp
+++ b/main.cpp
@@ -8,6 +8,7 @@ int main()
 int a, b;
 cin >> a >> b;
 cout << "A + B = " << a + b << '\n';
+cout << "A - B = " << a - b << '\n';

     return 0;
 }
```
18. сравнили первый с разностью 
```
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show HEAD~5 HEAD~1
commit 98b3f1e8bd7eeb38263439ec1e2b707c5433cff9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 19:32:19 2025 +0300

    code: заготовка программы

diff --git a/main.cpp b/main.cpp
new file mode 100644
index 0000000..b4392ec
--- /dev/null
+++ b/main.cpp
@@ -0,0 +1,9 @@
+#include <iostream>
+
+using namespace std;
+
+int main()
+{
+    cout << "Hello world!" << endl;
+    return 0;
+}

commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

diff --git a/main.cpp b/main.cpp
index 443df7f..f0a0233 100644
--- a/main.cpp
+++ b/main.cpp
@@ -8,6 +8,7 @@ int main()
 int a, b;
 cin >> a >> b;
 cout << "A + B = " << a + b << '\n';
+cout << "A - B = " << a - b << '\n';

     return 0;
 }
```
19. Откат изменений 2 способа
```
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m "product"
[main 5019f67] product
 1 file changed, 1 insertion(+), 1 deletion(-)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git status
On branch main
nothing to commit, working tree clean

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git show head
commit 5019f6757ae958a5f01ece9b4986444a8b22ea4c (HEAD -> main)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 22:39:34 2025 +0300

    product

diff --git a/main.cpp b/main.cpp
index f0a0233..e4d4925 100644
--- a/main.cpp
+++ b/main.cpp
@@ -9,6 +9,6 @@ int a, b;
 cin >> a >> b;
 cout << "A + B = " << a + b << '\n';
 cout << "A - B = " << a - b << '\n';
-
+cout << "A * B = " << a * b << '\n';
     return 0;
 }

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git reset --hard HEAD~1
HEAD is now at e9f694b git

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git checkout HEAD -- main.cpp
 ```
 20.Выгрузка на сервер
 $ git checkout HEAD -- main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ ssh-keygen
Generating public/private ed25519 key pair.
Enter file in which to save the key (/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519):
Created directory '/c/Users/\320\232\320\243\320\232\320\236\320\233\320\224\320\230\320\235\320\254\320\236/.ssh'.
Enter passphrase for "/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519" (empty for no passphrase):
Enter same passphrase again:
Your identification has been saved in /c/Users/КУКОЛДИНЬО/.ssh/id_ed25519
Your public key has been saved in /c/Users/КУКОЛДИНЬО/.ssh/id_ed25519.pub
The key fingerprint is:
SHA256:Z8MpaZ11t3nJ+rCGOv/unVZ0P+yLNpe7bvsMW24Ha8c КУКОЛДИНЬО@DESKTOP-1A2SHQB
The key's randomart image is:
+--[ED25519 256]--+
|                 |
|                 |
|            . . .|
|         + + ...*|
|        S O   .*+|
|       . + .  oo+|
|            .oo+=|
|         . . +O%E|
|         .+.*BB%@|
+----[SHA256]-----+

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ eval $(ssh-agent -s)
Agent pid 2489

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ ssh-add
Enter passphrase for /c/Users/КУКОЛДИНЬО/.ssh/id_ed25519:
Identity added: /c/Users/КУКОЛДИНЬО/.ssh/id_ed25519 (КУКОЛДИНЬО@DESKTOP-1A2SHQB)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ cat ~/.ssh/id_ed25519.pub
ssh-ed25519 AAAAC3NzaC1lZDI1NTE5AAAAIITuJAlqidy99/DmK7ouAte19QbN8IWXTOM3xo+dridi КУКОЛДИНЬО@DESKTOP-1A2SHQB

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git remote add origin git@uit.mpei.ru:YashechkinGA/cs-lab02.git
git push -u origin main
The authenticity of host 'uit.mpei.ru (193.233.68.149)' can't be established.
ED25519 key fingerprint is SHA256:Q5w0UKEzQKA3J6NyMtjwCLvtAykoxdugIXjx6NwU4NA.
This key is not known by any other names.
Are you sure you want to continue connecting (yes/no/[fingerprint])? yes
Warning: Permanently added 'uit.mpei.ru' (ED25519) to the list of known hosts.
Enumerating objects: 18, done.
Counting objects: 100% (18/18), done.
Delta compression using up to 4 threads
Compressing objects: 100% (16/16), done.
Writing objects: 100% (18/18), 2.12 KiB | 217.00 KiB/s, done.
Total 18 (delta 2), reused 0 (delta 0), pack-reused 0 (from 0)
remote: . Processing 1 references
remote: Processed 1 references in total
To uit.mpei.ru:YashechkinGA/cs-lab02.git
 * [new branch]      main -> main
branch 'main' set up to track 'origin/main'.
 21. "Восстания Боба из мёртвых"
 ```
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ git clone  git@uit.mpei.ru:YashechkinGA/cs-lab02.git project
Cloning into 'project'...
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
remote: Enumerating objects: 18, done.
remote: Counting objects: 100% (18/18), done.
remote: Compressing objects: 100% (16/16), done.
remote: Total 18 (delta 2), reused 0 (delta 0), pack-reused 0
Receiving objects: 100% (18/18), done.
Resolving deltas: 100% (2/2), done.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ cd project

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git config user.name 'Bob (YashechkinGA)'
git config user.email 'YasheckinGA@mpei.ru'

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git add main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git status
On branch main
Your branch is up to date with 'origin/main'.

Changes to be committed:
  (use "git restore --staged <file>..." to unstage)
        modified:   main.cpp


КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git commit -m "product"
[main 9d54cb7] product
 1 file changed, 1 insertion(+), 1 deletion(-)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git log head
commit 9d54cb7fa7611cf5d960b6323fac744087660afc (HEAD -> main)
Author: Bob (YashechkinGA) <YasheckinGA@mpei.ru>
Date:   Mon Apr 7 01:43:22 2025 +0300

    product

commit e9f694bf050b729345b118e1f7174a95d0c8c0fd (origin/main, origin/HEAD)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:26:22 2025 +0300

    git

commit cbc3b422bd7991ff2f4bdd49ff7de0d48754d256
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:04:31 2025 +0300

    ...

commit 70761119e12a9928971eadd1c5d8c252254944e9
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 6 20:01:08 2025 +0300

    ...
21. выгрузка коммитов боба и алисы и замена данных через git french
 
 КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git add main.cpp

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git commit -m "del Alice"
[main 6357c04] del Alice
 1 file changed, 1 insertion(+)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git push
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Enumerating objects: 5, done.
Counting objects: 100% (5/5), done.
Delta compression using up to 4 threads
Compressing objects: 100% (3/3), done.
Writing objects: 100% (3/3), 384 bytes | 192.00 KiB/s, done.
Total 3 (delta 1), reused 0 (delta 0), pack-reused 0 (from 0)
remote: . Processing 1 references
remote: Processed 1 references in total
To uit.mpei.ru:YashechkinGA/cs-lab02.git
   9d54cb7..6357c04  main -> main

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log --oneline --decorate --all --graph
* 6357c04 (HEAD -> main, origin/main, origin/HEAD) del Alice
* 9d54cb7 product
* e9f694b git
* cbc3b42 ...
* 7076111 ...
* 8700c05 ...
* 026a0ad build: add project file
* 98b3f1e code: заготовка программы

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git pull --ff-only
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Already up to date.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git status
On branch main
Your branch is up to date with 'origin/main'.

Untracked files:
  (use "git add <file>..." to include in what will be committed)
        project.depend

nothing added to commit but untracked files present (use "git add" to track)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git pull --ff-only
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Already up to date.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ cd ..

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice
$ cd ..

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ cd bob

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ git pull --ff-only
fatal: not a git repository (or any of the parent directories): .git

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ git fetch
fatal: not a git repository (or any of the parent directories): .git

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ git fetch
fatal: not a git repository (or any of the parent directories): .git

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ git status
fatal: not a git repository (or any of the parent directories): .git

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ cd project

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git fetch
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
remote: Enumerating objects: 5, done.
remote: Counting objects: 100% (5/5), done.
remote: Compressing objects: 100% (3/3), done.
remote: Total 3 (delta 1), reused 0 (delta 0), pack-reused 0
Unpacking objects: 100% (3/3), 364 bytes | 11.00 KiB/s, done.
From uit.mpei.ru:YashechkinGA/cs-lab02
   9d54cb7..6357c04  main       -> origin/main

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git pull --ff-only
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Updating 9d54cb7..6357c04
Fast-forward
 main.cpp | 1 +
 1 file changed, 1 insertion(+)
	```
 22. ар
КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git show head
commit 1fe17016fe98347b293b5938538b839616ea5c92 (HEAD -> main)
Author: Bob (YashechkinGA) <YasheckinGA@mpei.ru>
Date:   Mon Apr 7 03:36:54 2025 +0300

    min bob

diff --git a/main.cpp b/main.cpp
index 7c03b22..bb4726d 100644
--- a/main.cpp
+++ b/main.cpp
@@ -11,5 +11,13 @@ cout << "A + B = " << a + b << '\n';
 cout << "A - B = " << a - b << '\n';
 cout << "A * B = " << a * b << '\n';
 cout << "A / B = " << a / b << '\n';
+if (a < b)
+{
+    cout << "Min-A= " << a;
+}
+if (a > b)
+{
+    cout << "Min-B= " << b;
+}
     return 0;
 }

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ cd ..

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob
$ cd ..

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02
$ cd alice

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice
$ cd project

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git push
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Everything up-to-date

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$
```
23. Решение конфликтов правок
```

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git rebase origin/main
Current branch main is up to date.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git push
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
To uit.mpei.ru:YashechkinGA/cs-lab02.git
















































[detached HEAD f814e82] Min bob
 1 file changed, 8 insertions(+)
Successfully rebased and updated refs/heads/main.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/bob/project (main)
$ git push
Enter passphrase for key '/c/Users/КУКОЛДИНЬО/.ssh/id_ed25519':
Enumerating objects: 5, done.
Counting objects: 100% (5/5), done.
Delta compression using up to 4 threads
Compressing objects: 100% (3/3), done.
Writing objects: 100% (3/3), 376 bytes | 125.00 KiB/s, done.
Total 3 (delta 1), reused 0 (delta 0), pack-reused 0 (from 0)
remote: . Processing 1 references
remote: Processed 1 references in total
To uit.mpei.ru:YashechkinGA/cs-lab02.git
   3f01321..f814e82  main -> main

```
20.

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice
$ cd project

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git checkout double
Switched to branch 'double'

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (double)
$ git add main.cpp
















































Auto-merging main.cpp
Merge made by the 'ort' strategy.
 main.cpp | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

КУКОЛДИНЬО@DESKTOP-1A2SHQB MINGW64 ~/Desktop/lab02/alice/project (main)
$ git log
commit 0ee6bd2c21776e9d601a5dd6a236314dd8cf0c2c (HEAD -> main)
Merge: f814e82 51a4c6d
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 13 15:36:59 2025 +0300

    Merge branch 'double'

commit 51a4c6d54224ad653069f04198d4a2ca19e8a419 (double)
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sun Apr 13 15:20:18 2025 +0300

    double Alice

commit f814e824825714511a916340a97044c333012e3b (origin/main, origin/HEAD)
Author: Bob (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sat Apr 12 16:14:21 2025 +0300

    Min bob

commit 3f013215fb05b6abebbed439c6419df2d823e8e7
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sat Apr 12 16:10:27 2025 +0300

    Max Alice

commit 79aa97e804a89147009b7e590ad90a9d9e1ccfa5
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sat Apr 12 15:41:03 2025 +0300

    del Alice

commit d057aeef375bce55af4427ce61d09665b4b021ae
Author: Bob (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Sat Apr 12 15:22:10 2025 +0300

    product Bob

commit c220ea7aaea8d3c48c82e818a599060e6732d845
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Fri Apr 11 20:08:59 2025 +0300

    git

commit 02c0ba7e1b54a8f9a02f2e9bb868bf8af28e721b
Author: Alice (YashechkinGA) <YashechkinGA@mpei.ru>
Date:   Fri Apr 11 20:00:50 2025 +0300

    ...
:

 
 
 